<!DOCTYPE html>
<html>

<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <title>Multicloud map</title>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.5.16/vue.js"></script>
  <link rel="stylesheet" type="text/css" href="https://unpkg.com/leaflet@1.0.3/dist/leaflet.css">
  <script type="text/javascript" src="https://unpkg.com/leaflet@1.0.3/dist/leaflet.js"></script>
  <script type="text/javascript" src="https://unpkg.com/vue2-leaflet@1.0.1/dist/vue2-leaflet.js"></script>
  <script src="https://unpkg.com/axios/dist/axios.min.js"></script>
  <style type="text/css">
    html,
    body,
    #app {
      height: 99%;
      margin: 0;
    }

    .provider-logo {
      max-width: 300px;
    }

    /* DIY Navbar*/

    ul.nav {
      list-style-type: none;
      margin: 0;
      padding: 0;
      overflow: hidden;
      background-color: #333;
      height: 3em;
    }

    ul.nav li {
      float: left;
      display: block;
      color: white;
      text-align: center;
      padding: 1em 2em;
      text-decoration: none;
    }

    ul.nav .right {
      float: right;
    }
  </style>

  <script type="text/javascript">
    window.onload = function() {

      var {
        LMap,
        LTileLayer,
        LMarker,
        LCircleMarker,
        LPopup
      } = Vue2Leaflet;

      new Vue({
        el: '#app',
        components: {
          LMap,
          LTileLayer,
          LMarker,
          LCircleMarker,
          LPopup
        },
        data() {
          setInterval(function() {
            this.ping_gitlab();
            this.ping_kubernetes();
          }.bind(this), 1000);
          return {
            gitlab_api: 'https://gitlab.root314.com/api/v4',
            gitlab_token: '',
            project_id: 1,
            zoom: 3,
            center: L.latLng(50, -20),
            url: 'http://{s}.tile.osm.org/{z}/{x}/{y}.png',
            attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
            domain: 'k8s.root314.com',
            colors: {
              created: 'green',
              pending: 'green',
              success: 'green',
              unknown: 'black',
              failed: 'red',
            },
            logos: {
              CityCloud: 'https://www.citynetworkhosting.com/wp-content/uploads/2015/06/CityCloud-Logo-Regular-2015-RGB-300x80.png',
              ElastX: 'https://elastx.se/sites/default/files/ELASTX_0_1.png',
              Zetta: 'https://www.zetta.io/static/images/logo.png',
              VexxHost: 'https://vexxhost.com/file/2017/03/vexxhost-logo-01.svg',
              Auro: 'https://login.van2.auro.io/static/dashboard/img/logo-splash.svg',
              OVH: 'https://www.ovh.com/world/images/logo/ovhLogoColor.svg',
              FugaCloud: 'https://cyso.secure.footprint.net/fuga-assets/dist/images/branding/fuga-cloud-blue-transparent.png',
              EnterCloudSuite: 'https://www.entercloudsuite.com/img/brand@3x.png',
              BetaCloud: 'https://i.imgur.com/DlrOFAJ.png',
              Ultimum: 'https://ultimum.io/static/images/logo.de2a6d6c84b1.png',
              DreamHost: 'https://iad2.dreamcompute.com/static/dashboard/img/logo.svg',
              TSystems: 'https://www.t-systems.com/blob/4868/5ee00b0443d42ef5998eef4b5721e293/T-Systems-Logo.png',
              Orange: 'https://c.woopic.com/logo-orange.png',
              Packet: 'https://www.packet.com/media/pages/images/b8c27b7a1c450ffdacb31483454e0b54/q6Qc-packetlogocolor.jpg',
              ScaleUp: 'https://www.scaleuptech.com/de/wp-content/uploads/2015/05/logo_header.png',
              LimestoneNet: 'https://cloud.lstn.net/static/dashboard/img/logo-splash.svg',
              TeutoStack: 'https://teutostack.de/wp-content/uploads/2014/10/teutostack-logo_hd.png',
              Syseleven: 'https://www.syseleven.de/wp-content/uploads/2018/07/SysEleven_LogoSysEleven_Logo_New-2.png',
              CloudAndHeat: 'https://i.postimg.cc/7Z8qvWDP/02-C-H-Black-on-clear-portrait.png',
            },
            markers: [],
          }
        },
        mounted() {
          if (localStorage.gitlab_token) this.gitlab_token = localStorage.gitlab_token;
          axios
            .get('clouds.json')
            .then(response => (this.markers = response.data))
        },
        methods: {
          ping_kubernetes() {
            this.markers.forEach(function(element) {
              axios.get('http://' + element.cluster.toLowerCase() + '.k8s.root314.com/')
                .then(response => {
                  element.cluster_status = 'success';
                })
                .catch(error => {
                  element.cluster_status = 'failed';
                });
            });
          },
          status(field, status) {
            return this.markers.map(x => x[field] == status).reduce((x, y) => x + y, 0);
          },
          gl(path) {
            if (this.gitlab_token.length == 0) {
              this.gitlab_token = prompt('GitLab API Token');
              localStorage.gitlab_token = this.gitlab_token;
            }
            opts = {
              headers: {
                'Private-Token': this.gitlab_token
              }
            };
            return axios.get(this.gitlab_api + path, opts);
          },
          ping_gitlab() {
            this.gl('/projects/' + this.project_id + '/pipelines?per_page=1').then(
              response => {
                this.pipeline_id = response.data[0].id;
                this.gl('/projects/' + this.project_id + '/pipelines/' + this.pipeline_id + '/jobs?per_page=100').then(
                  response => {
                    response.data.forEach(job => {
                      if (job.stage == 'production') {
                        console.log(job);
                        this.markers.find(x => {
                          return x.cluster == job.name
                        }).app_status = job.status;
                      }
                    })
                  }
                )
              }
            )

          }
        }

      });


    }
  </script>

</head>

<body>

  <body>
    <div id="app">
      <ul class="nav">
        <li>Clusters up: {{ status('cluster_status', 'success') }}/{{ markers.length }}</li>
        <li class="right">Apps deployed: {{ status('app_status', 'success') }}/{{ markers.length }}</li>
        <li class="right">Apps upgrading: {{ status('app_status', 'running') }}/{{ markers.length }}</li>
      </ul>

      <l-map :zoom="zoom" :center="center">
        <l-tile-layer :url="url" :attribution="attribution"></l-tile-layer>
        <l-circle-marker v-for="item in markers" :radius="8" :color="colors[item.app_status]" :fill-color="colors[item.cluster_status]" :fill-opacity="0.4" :key="item.id" :lat-lng="item.latlng" :visible="item.visible" :draggable="item.draggable">
          <l-popup>
            <h1>{{ item.cluster }}</h1>
            <img v-if="item.provider in logos" :src="logos[item.provider]" class="provider-logo" />
            <ul>
              <li>Provider: {{ item.provider }}</li>
              <li v-if=""><a :href="'http://' + item.cluster + '.' + domain">{{ item.cluster + '.' + domain }}</a></li>
              <li>Cluster status: <strong>{{ item.cluster_status }}</strong></li>
              <li>App status: <strong>{{ item.app_status }}</strong></li>
            </ul>
          </l-popup>
          </l-marker>
      </l-map>
    </div>
  </body>

</html>
